function [x_new P_new P_cross] = Filter(y, A, R, D, gamma, x_old, P_old)

% Inputs:
% A     : A_k
% R     : R_k
% x_old : x_{k-1|k-1}
% P_old : P_{k-1|k-1}
% y     : y_k

N = length(gamma);
Gamma = diag(gamma);

x_temp  = D*x_old;                      % x_{k|k-1}
P_temp  = D*P_old*D + Gamma*(eye(N) - D^2);  % P_{k|k-1}
J_t     = P_temp*A'*(R+A*P_temp*A')^-1; % J_t
J_new   = eye(N) - J_t*A;               % I - J_tA
x_new   = J_new*x_temp + J_t*y;          % x_{k|k}
P_new   = J_new*P_temp;             % P_{k|k}
P_cross = J_new*D*P_new;           % P_{k,k-1|k}
