function [x_new P_new P1_new] = Fixed_Interval(y, A, R, D, gamma, x_old, P_old);

N = length(gamma);
L = size(y,2);

x_temp = zeros(N,L);
P_temp = zeros(N,N,L);

x_new = zeros(N,L);
P_new = zeros(N,N,L);
P1_new = zeros(N,N,L-1);

for t = 1 : L
    A_t = get_matrix(A,t,t);
    R_t = get_matrix(R,t,t);
    if t > 1
        mu = x_temp(:,t-1);
        P = P_temp(:,:,t-1);
    else
        mu = x_old;
        P = P_old;
    end
    
    [x_temp(:,t) P_temp(:,:,t) P_cross] = Filter(y(:,t), A_t, R_t, D, gamma, mu, P);
end;
if L > 1
    P1_new(:,:,L-1) = P_cross;
end
P_new(:,:,L)  = P_temp(:,:,L);
x_new(:,L)  = x_temp(:,L);

extra = diag(gamma)*(eye(N) - D^2);
G = zeros(N,N);
for t = L-1 : -1: 1
    G_old = G;
    P_temp_old = D*P_temp(:,:,t)*D + extra;
    G = P_temp(:,:,t)*D*P_temp_old^-1;
    x_new(:,t) = x_temp(:,t) + G*(x_new(:,t+1) - D*x_temp(:,t));
    P_new(:,:,t) = P_temp(:,:,t) + G* (P_new(:,:,t+1) - P_temp_old)*G';
    if t ~= L-1
        P1_new(:,:,t) = P_temp(:,:,t+1)*G' + G_old* (P1_new(:,:,t+1) - D*P_temp(:,:,t+1))*G';
    end;
end;




    