function [X_rec count] = fixed_interval_rec(Y, phi, rho, stdnoise)

%% Initilize

% Dimensions
[m N K] = size(phi);

% Initialize
gamma = 4*ones(N,1);
D = diag(rho); 
count = 0;

% Control parameters
EPSILON     = 1e-5;       % threshold for stopping iteration. 
MAX_ITER    = 2000;       % maximum iterations

%% E-M iterations

while(1)
                      % kalman_forward_backward(A, C, R, y, g)
    [gamma_new X_rec] = kalman_forward_backward( D, phi, stdnoise, Y, gamma);
        norm(gamma_new - gamma);
    if norm(gamma_new - gamma) < EPSILON
        break; end;
    if count >= MAX_ITER
    	break; end;
    gamma = gamma_new;
    
    count = count+1
end;
