%TO Do: try LS with prior, i.e. min distance from 0. 
%Because LS will also fit to observation noise
% multiple iterations
% Removed u>=0 constraint from cs_solve

randn('state',0); rand('state',0); disp('random state 0 on')

m = 256;    n = 72;     S =  8; % round( n/log2(m/n) )
cc = 1; %10 %multiply 'sigma' and 'a' by 'cc'
sigma0 =  cc* (1/3)*sqrt(S/n)
lambdap = 4 %beta = 2; lambdap = sqrt( (1+beta)*2*log2(m) ); prob_lb = 1 - 1/( sqrt(pi*log2(m))*m^beta )
% fix A
Agen = (1/sqrt(n)) * randn(n,m);
A = zeros(size(Agen));
for col = 1:m
    A(:,col) = Agen(:,col)/norm( Agen(:,col) );
end

% Data generation. Generate NZ directions, x and y
generate = 1

for ct = 1:55
    if generate
        T0 = ceil( rand(S,1)*m ); T = unique(T0);
        %    x = zeros(m,1); zeta = sign( rand(S,1) - 0.5 ); a = cc * randn(S,1); x(T) = zeta.*( sigma + 1 + abs(a) );
        %x(T)=cc : Maintain same SNR = 1/3 as far as x(T) is concerned, still increasing cc increases noise for other directions
        x = zeros(m,1);  x(T) = cc;
        y = A*x + sigma0*randn(n,1);
    end

    % Estimation. Number of changing directions = p
    %p = 2 %S
    for p = [2,S]
        T1 = T(1:S-p);  %T1 = [ceil(rand(p,1)*m ) , T(1:S-p) ] % Some 6 out of these 8 are actually NZ directions
        T_rest = setdiff([1:m]',T1);
        A1 = A(:,T1); A_rest = A(:,T_rest);
        y1 = y;
        for iter = 1:1
            x1_hat = inv(A1'*A1) * A1'*y1;
            y_rest = y - A1*x1_hat;
            [x_rest_hat_ls, x_rest_hat,T_rest_hat] = cs_solve(y_rest,A_rest,1,sigma0,lambdap);
            xhat = zeros(m,1);
            xhat(T1) = x1_hat; xhat(T_rest) = x_rest_hat_ls;
            T_hat = [T1;T_rest(T_rest_hat)];
          %  T_hat',T'
            y1 = y - A_rest*x_rest_hat_ls;
        end
        AT_hat = A(:,T_hat);
        xhat_nz_final =  inv(AT_hat'*AT_hat) * AT_hat'*y;
        xhat_final = zeros(m,1); xhat_final(T_hat) = xhat_nz_final; 
        ratio(ct,p) = norm(x-xhat)/norm(x);
        ratio_final(ct,p) = norm(x-xhat_final)/norm(x);
        not_detected(ct,p) = length( setdiff(T,T_hat) );
        extra_detected(ct,p) = length( setdiff(T_hat,T) );

        AT = A(:,T);
        xhat_ideal = zeros(size(x)); xhat_ideal(T) =  inv(AT'*AT) * AT'*y;
        ratio_ideal(ct,p) = norm(x-xhat_ideal)/norm(x);
        %err_ideal_I = sum( min( x.^2 , (sigma0^2)*ones(size(x)) ) ); ratio_ideal(ct) = err_ideal / norm(x);
    end
end